"""removes read items

algorithm:
	load list of hashes from the last run
	save current list
	remove items, which are on the list of the old
"""

import os

DEBUG = False

class main:
	def __init__(self, config):
		self.types = ['parser']
		self.config = config
		self.old_hashes = []
		self.data_file = os.path.expanduser(self.config.old_hashes)
		self.seperator = "]+["
	def load(self, file):
		"""load the self.data_file and fill self.old_hashes"""
		if not os.path.exists(file):
			return []
		else:
			old_hashes = []
			new = True
			fp = open(file, 'r')
			while new:
				line = fp.readline()[:-1]
				if not line:
					if DEBUG:
						print "not line, end loading hashes"
					new = False
					continue
				else:
					if DEBUG:
						print line
				if -1 == line.find(self.seperator): continue
				h, t = line.split(self.seperator)
				new = int(h)
				old_hashes.append( new )
			fp.close()
			if DEBUG:
				print "loaded %i old hashes" % len(old_hashes)
			return old_hashes
	def save(self, bunch, file):
		"""save self.bunch hashes to self.data_file"""
		# save the old_bunch
		fp = open(file, 'w')
		for item in bunch:
			try:
				title = item.title.encode('iso-8859-1', 'ignore')
			except: # isn't unicode at all
				title = item.title
			fp.write("%s%s%s\n" % (item.hash(), self.seperator, title))
		fp.close()
		if DEBUG:
			print "saved %i hashes" % len(bunch)
	def parse(self, bunch):
		if DEBUG:
			print "parsing %i items" % len(bunch)
		self.old_hashes = self.load(self.data_file) # load the old hashes from file
		# we save just the current hashes, because only they can appear the next
		# time and the oldhashes don't grow to infinite
		self.save(bunch, self.data_file)
		# index from end to start, because of the del, it would shift the index
		for x in range(len(bunch)-1, -1, -1):
			for oldhash in self.old_hashes:
				if bunch[x].hash() == oldhash:
					del bunch[x]
					break
		return bunch
