"""creates a html file of the items"""

import codecs, datetime, sys, os

HTML_TEMPLATE = sys.prefix + "/share/feedisto/feedisto.html_template"
DEBUG = False

class main:
	def __init__(self, config):
		self.config = config
		self.types = ['output']
		self.filename = os.path.expanduser(self.config.static_html_file)
		self.page = ""
		self.template = config.html_template
		if not self.template:
			if os.path.exists(HTML_TEMPLATE):
				self.template = HTML_TEMPLATE
			else:
				raise "No HTML template found at", HTML_TEMPLATE
		else:
			self.template = os.path.expanduser(self.template)
		for line in open(self.template):
			self.page += line
		if DEBUG:
			print "StaticHTML loaded; Template:", self.template
	def put(self, bunch):
		if len(bunch) < 1:
			if DEBUG:
				print "StaticHTML got no items, returning"
			return
		date = datetime.datetime.now().strftime(" %d.%m.%Y %H:%M ") 
		page = self.page
		page = page.replace("#title#", self.config.title)
		page = page.replace("#subtitle#", self.config.subtitle)
		page = page.replace("#date#", date)
		for item in bunch:
			new = item.html()
			page = page.replace("#content#", new + "\n#content#")
		page = page.replace("#content#", "")
		(encoding,decoding,reader,writer) = codecs.lookup('UTF-8')
		fp = writer(open(self.filename, 'wb'))
		fp.write(page)
		fp.close()
		if DEBUG:
			print "wrote static html to", self.filename
